'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MenuAccordion = undefined;

var _d2Utilizr = require('d2-utilizr');

var _MenuAccordion;

exports.MenuAccordion = _MenuAccordion;
exports.MenuAccordion = _MenuAccordion = function MenuAccordion(config) {
    var t = this;

    var tabHeight = 28;

    config = (0, _d2Utilizr.isObject)(config) ? config : {};
    t.tabs = config.items;

    // items
    t.accordionBody = Ext.create('Ext.panel.Panel', {
        layout: 'accordion',
        activeOnTop: true,
        cls: 'ns-accordion',
        bodyStyle: 'border:0 none; margin-bottom:2px',
        height: 700,
        items: config.items
    });

    // constructor
    $.extend(this, Ext.create('Ext.panel.Panel', {
        bodyStyle: 'border-style:none; padding:1px; padding-bottom:0; overflow-y:scroll;',
        items: t.accordionBody
    }));

    // references
    t.uiManager = _MenuAccordion.uiManager;
    t.uiConfig = _MenuAccordion.uiConfig;
};

_MenuAccordion.prototype.setThisHeight = function (mx) {
    var t = this,
        panelHeight = this.tabs.length * this.tabHeight,
        height;

    if (this.uiManager.hasWestRegionScrollbar) {
        height = panelHeight + mx;
        this.setHeight(t.uiManager.getHeight() - 2);
        this.accordionBody.setHeight(height - 2);
    } else {
        height = t.uiManager.getHeight() - this.uiConfig.west_fill;
        mx += panelHeight;
        this.setHeight((height > mx ? mx : height) - 2);
        this.accordionBody.setHeight((height > mx ? mx : height) - 2);
    }
};

_MenuAccordion.prototype.getExpandedTab = function () {
    this.tabs.forEach(function (tab) {
        if (!tab.collapsed) {
            return tab;
        }
    });

    return null;
};

_MenuAccordion.prototype.getFirstPanel = function () {
    return this.tabs[0];
};

_MenuAccordion.prototype.applyTo = function (modules) {
    var t = this;

    (0, _d2Utilizr.arrayTo)(modules).forEach(function (module) {
        module.menuAccordion = t;
    });
};
//# sourceMappingURL=MenuAccordion.js.map