'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.OutputTypeSelect = undefined;

var _Style = require('./Style');

var _Style2 = _interopRequireDefault(_Style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OutputTypeSelect = function OutputTypeSelect(refs) {
    var i18n = refs.i18nManager.get();

    return Ext.create('Ext.form.field.ComboBox', {
        cls: 'ns-combo',
        style: 'margin-bottom:' + _Style2.default.comboBottomMargin + 'px',
        width: _Style2.default.cmpWidth,
        labelWidth: _Style2.default.labelWidth,
        fieldLabel: i18n.output_type,
        labelSeparator: null,
        labelStyle: 'color:#333',
        queryMode: 'local',
        valueField: 'id',
        editable: false,
        value: 'EVENT',
        store: Ext.create('Ext.data.Store', {
            fields: ['id', 'text'],
            data: [{ id: 'EVENT', text: i18n.event }, { id: 'ENROLLMENT', text: i18n.enrollment }, { id: 'TRACKED_ENTITY_INSTANCE', text: i18n.tracked_entity_instance }]
        })
    });
};

exports.OutputTypeSelect = OutputTypeSelect;
exports.default = OutputTypeSelect;
//# sourceMappingURL=OutputType.js.map